<template id="category-beneficiary-stats">
  <div class="box box-warning">
    <div class="box-header with-border">
      <h3 class="box-title">Category beneficiary stats</h3>
      <div class="box-tools pull-right">
        <button
          v-if="!show_table"
          @click="showAndHideComponents(true,false,false)"
          type="button"
          class="btn show-table-btn"
        >
          <i class="fa fa-table"></i>
        </button>
        <button
          v-if="!show_line_chart"
          @click="showAndHideComponents(false,true,false)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-line"></i>
        </button>
        <button
          v-if="!show_bar_chart"
          @click="showAndHideComponents(false,false,true)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-bar"></i>
        </button>
      </div>
    </div>

      <div class="box-body">
      <div class="chart">
        <div class="card">
          <div class="card-body">
       <div class="category-selector-area">
              <select
                class="form-control"
                id="category_name"
                v-model="selected_category"
                @change="onChangeCategory()"
              >
                <option value disabled>Select category</option>
               <option
                  v-for="(category,key) in categories"
                  v-bind:value="category"
                  v-bind:key="category"
                >{{ key }}</option>
              </select>
            </div>
            <br/>
            <div class="beneficiary-selector-area">
              <select
                id="beneficiary"
                v-model="selected_beneficiary"
                @change="onChangeBeneficiary()"
                class="form-control"
              >
                <option value disabled>Select beneficiary</option>

                <option
                  v-for="(beneficiary,key) in mutableBeneficiaries"
                  v-bind:key="key"
                  v-bind:value="beneficiary"
                >{{ key }}</option>
              </select>
            </div>
            <hr>
            <div class="chart">
              <LineChart v-if="show_line_chart" :chartData="chartData" :options="optionsLine"></LineChart>
              <BarChart v-if="show_bar_chart" :chartData="chartData" :options="optionsBar"></BarChart>
            </div>
            <div v-if="show_table && tableStats">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Date</th>
                    <th>Amount, €</th>
                  </tr>

                  <tr v-for="result in tableStats.data" :key="result.date">
                    <td>{{ result.date}}</td>
                    <td>{{ result.sum }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div v-if="show_table" class="card-footer">
              <pagination
                class="paginator"
                :data="tableStats"
                @pagination-change-page="getTableStats"
              ></pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- /.box-body -->
  </div>
</template>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.13.0/moment.min.js"></script>
<script src="https://chartjs-plugin-datalabels.netlify.com/guide/positioning.html#clamping"></script>

<script>
import LineChart from "./LineChart.vue";
import BarChart from "./BarChart.vue";
import moment from "moment";
export default {
  props: ["date_interval", "beneficiaries", "categories", "stats", "interval"],

  components: {
    LineChart,
    BarChart
  },
  data: function() {
    return {
      chartData: null,
      optionsBar: null,
      optionsLine: null,
      selected_beneficiary: null,
      selected_category: null,
      tableStats: {},
      show_table: false,
      show_line_chart: true,
      show_bar_chart: false,
      mutableBeneficiaries: this.beneficiaries
    };
  },

  created: function() {
    this.selected_category = Object.values(this.categories)[0];
    this.selected_beneficiary = Object.values(this.mutableBeneficiaries)[0];
    this.setChartValues(this.stats);
  },

  watch: {
    date_interval: function() {
      this.setChartValues(this.stats);
      this.show_table = false;
    },

    stats: function() {
      this.setChartValues(this.stats);
      this.selected_category = Object.values(this.categories)[0];
      this.selected_beneficiary = Object.values(this.mutableBeneficiaries)[0];
    }
  },

  methods: {
    showAndHideComponents(table, line, bar) {
      if (table) {
        this.show_table = true;
        this.getTableStats();
      } else if (line) {
        this.show_table = false;
        this.show_bar_chart = false;
        this.show_line_chart = true;
      }

      if (bar) {
        this.show_table = false;
        this.show_bar_chart = true;
        this.show_line_chart = false;
      }
    },

    onChangeCategory() {
      this.getCategoryBeneficiaries();
      this.show_table = false;
    },

    getCategoryBeneficiaries() {
      let uri = "api/transaction/beneficiaries/" + this.interval + "/" + this.selected_category;

      axios
        .get(uri)
        .then(response => {
          this.mutableBeneficiaries = response.data;
          this.selected_beneficiary = Object.values(
            this.mutableBeneficiaries
          )[0];
          this.getChartValues();
        });
    },

    onChangeBeneficiary() {
      this.show_table = false;
      this.getChartValues();
    },

    statsUrl(pagin) {
      let uri =
        "api/category-beneficiary-stats/" +
        this.selected_beneficiary +
        "/" +
        this.selected_category +
        "/" +
        this.interval +
        "?paginate=" +
        pagin;

      return uri;
    },

    getTableStats(page = 1) {
      axios
        .get(this.statsUrl(1), {
          params: {
            page: page
          }
        })
        .then(response => {
          this.tableStats = response.data.results;
        });
    },

    getChartValues() {
      axios.get(this.statsUrl(0)).then(response => {
        this.setChartValues(response.data);
      });
    },

    setChartValues: function(stats) {

      let labels = stats.results.map(list => {
        return list.date;
      });

      let amounts = stats.results.map(list => {
        return list.sum.toFixed(1);
      });

      this.assignChartValues(labels, amounts);
    },

    assignChartValues: function(labels, amounts) {
      this.chartData = {
        labels: labels,
        datasets: [
          {
            label: "Transaction sum",
            backgroundColor: "#a7d975",
            borderColor: Fire.getRandomColorHex(),
            fill: true,
            data: amounts,
            datalabels: {
              labels: {
                title: null
              }
            }
          }
        ]
      };
      this.optionsLine = {
        tooltips: {
          callbacks: {
            label: function(tooltipItem, data) {
              return data["datasets"][0]["data"][tooltipItem["index"]] + " €";
            }
          }
        },
        title: {
          display: false,
          text: "just a code snippet ..."
        },
        scales: {
          yAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "Amount, €"
              }
            }
          ],
          xAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "dates"
              }
            }
          ]
        },

        legend: {
          display: false,
          labels: {
            boxWidth: 0
          },

          onClick: e => e.stopPropagation()
        }
      };

      this.optionsBar = Object.assign({}, this.optionsLine);

        this.optionsBar.scales.yAxes[0].ticks = {
        beginAtZero: true
      };
    }
  }
};
</script>